'Filename:  Backup.vbs

Option Explicit
'on Error Resume Next

'________________Sub FindSpace______________________________________

' Find free space on a drive and append this info to msg string:

Sub FindSpace(drive, msg)

   Dim space
   Dim units

   space = drive.FreeSpace
   if space > 1073741824 then
      space = Round(space / 1073741824, 2)
      units = "gigabytes"
   elseif space > 1048576 then
      space = Round(space / 1048576, 2)
      units = "megabytes"
   elseif space > 1024 then
      space = Round(space / 1024, 2)
      units = "kilobytes"
   else
      units = "bytes"
   end if

   msg = msg & "Free space on backup drive: "  _
      & space & " (" & units & ")" & vbCRLF
End Sub

'________________Sub FindDirectories______________________________________

'Recurse thru directories finding all subdirectories and files

Sub FindDirectories (strSourceDir, strBackupDir)

dim objFolder, colfolders, colFiles, FolderObj, FileObj, strBackupPath, MyDir
Dim logfilename, logfileobj

Dim total, count

set objFolder = objFileSystem.GetFolder(strSourceDir)
set colfolders = objFolder.Subfolders
For Each FolderObj In colfolders

	MyDir = FolderObj.Name
	strBackupPath = strBackupDir & MyDir & "\"

	If Not objFileSystem.FolderExists(strBackupPath) Then
	    objFileSystem.CreateFolder(strBackupPath)
	End If

	strBackupPath = strBackupPath & strBackupDate & "\"
	If Not objFileSystem.FolderExists(strBackupPath) Then
	    objFileSystem.CreateFolder(strBackupPath)
	End If

	strBackupPath = strBackupPath & strBackupTime & "\"
	If Not objFileSystem.FolderExists(strBackupPath) Then
	    objFileSystem.CreateFolder(strBackupPath)
	End If

	logfilename = strBackupDir & MyDir & "\" & strBackupDate & "\"& "LogFile.txt"
	set logfileobj = objFileSystem.OpenTextFile(logfilename, 8, True)
	logfileobj.WriteLine("Backup Info:" & vbCrLf & strJob & vbCrLf &  vbCrLf & "Created output folder " & strBackupPath  & vbCrLf)
	joblogfileobj.WriteLine("Created output folder " & strBackupPath)

	total = 0
	count = 0

	set colFiles = FolderObj.Files
	For Each FileObj In colFiles

     	logfileobj.WriteLine("Copied: " & FileObj.Name & vbTab & " size: " & FileObj.Size & vbTab & " Last Modified: " & FileObj.DateLastModified)
    	total = total + FileObj.Size
    	count = count + 1
    	objFileSystem.CopyFile strSourceDir & "\" & FolderObj.Name & "\" & FileObj.Name, strBackupPath & FileObj.Name 

	Next 'file

	strNotice = vbCRLF & "Totals For " & MyDir & ", backed up" & vbTab & count & " file(s) " & total & " bytes"
	logfileobj.WriteLine(strNotice & vbCRLF & "_________________________________________________________________________")
	logfileobj.Close()

	if count > 0 then 
		joblogfileobj.WriteLine(strNotice & vbCRLF)
	end if

    WshShell.Popup strNotice,3 , "Backup.vbs 2002 BarWareSolutions", 65

	grandtotal = grandtotal + total
	totalcount = totalcount + count


	FindDirectories strSourceDir & MyDir & "\", strBackupPath 'look for more subdirestories

Next 'folder
end sub

'________________Start of Main Program______________________________________

Dim WshShell, objFileSystem
Dim grandtotal, totalcount, strSourceDir, AUTOBACKUP, drive, space

grandtotal = 0
totalcount = 0

Dim strBackupDate, strBackupTime, strBackupDir, strDay, strMonth, strYear, strMinute, strHour
Dim joblogfilename, joblogfileobj

set WshShell = Wscript.CreateObject("Wscript.Shell")
set objFileSystem = Wscript.CreateObject("Scripting.FileSystemObject")

'________________Setup activities______________________________________

Dim args, num
set args = WScript.Arguments
num = args.Count

If num = 0 Then
	Dim strNotice 'msgbox text
    strNotice = "Usage: [CScript | WScript] Backup.vbs SourceDir [BackupFilespec] [auto]" & vbCrLf & vbCrLf & _
		"EX: WScript BackUp.vbs  C:\BackupIn  E:\Backup"  & vbCrLf & _
		"EX: WScript BackUp.vbs  ""C:\My Backups""  E:  auto" & vbCrLf & vbCrLf & _
		"Source directory is created using the Backup.cmd file, and is a directory " & _
		"containing other directories to be backed up.  Files in the root of this directory are not backed up."
    MsgBox strNotice, 48, "Backup.vbs 2002 BarWareSolutions" 
    WScript.Quit(1)
End If

strSourceDir = args.Item(0)
If Not objFileSystem.FolderExists(strSourceDir) Then 'Only Directories allowed
    WshShell.Popup strSourceDir & " " & "Doesn't exist, quitting.", , "Backup.vbs 2002 BarWareSolutions", 48 
    Wscript.quit(2)
End If
strSourceDir = strSourceDir & "\"

strBackupDir = "C:\Backup\" 'This would normally be a CD-R drive, but C as default
If num > 1 Then
    strBackupDir = args.Item(1) & "\"
End If

AUTOBACKUP=vbFALSE
if num = 3 then
	if args.Item(2) = "auto" then 
		AUTOBACKUP=vbTRUE
	end if
end if

set drive = objFileSystem.GetDrive(Left(strBackupDir,1))
FindSpace drive, space
space = "Before backup: " & space
dim strJob
strJob = "SourceDir: " & strSourceDir & vbCrLf & "BackupDir: " & strBackupDir & vbCrLf & vbCrLf & space

if not AUTOBACKUP then
	If Abs(MsgBox(strJob & vbCrLf & vbCrLf & "Hit OK to do the backup, Cancel to quit.", 33, "Backup.vbs 2002 BarWareSolutions")) <> 1 Then 
		WScript.Quit()
	end if
end if

strDay   = Right("00" & Cstr(Day(Date())),2)
strMonth = Right("00" & Cstr(Month(Date())),2)
strYear  = Cstr(Year(Date()))
strBackupDate = strYear & "_" & strMonth & "_" & strDay

strMinute = Right("00" & CStr(Minute(Time())), 2)
strHour = Right("00" & CStr(Hour(Time())), 2)
strBackupTime = strHour & "_" & strMinute

'________________End Setup activities__________________________________

If Not objFileSystem.FolderExists(strBackupDir) Then
    objFileSystem.CreateFolder(strBackupDir)
End If

joblogfilename = strBackupDir & "JobLogFile.txt"
set joblogfileobj = objFileSystem.OpenTextFile(joblogfilename, 8, True)

FindDirectories strSourceDir, strBackupDir

space = space & "After    backup: "
FindSpace drive, space
strNotice = "For job, backed up" & vbTab & totalcount & " file(s) " & grandtotal & " bytes" & vbCrLf & vbCrLf & vbCrLf & space

if totalcount > 0 then 
	joblogfileobj.WriteLine(strNotice & vbCRLF & "_________________________________________________________________________")
end if
joblogfileobj.Close()

WshShell.Popup strNotice, 60, "Backup.vbs 2002 BarWareSolutions", 65


wscript.quit()

