'Filename:  BackupDirectories.vbs

Option Explicit
'on Error Resume Next

dim WshShell, objFileSystem, objFolder, colFiles, FileObj
dim total, count, strFileName, strSourceDir, FULLBACKUP, SETUPSTUFF

total=0
count=0

Dim strBackupDate, strBackupTime, strBackupDir, strBackupPath, strDay, strMonth, strYear, strMinute, strHour
Dim logfilename, logfileobj

Set WshShell=Wscript.CreateObject("Wscript.Shell")
Set objFileSystem=Wscript.CreateObject("Scripting.FileSystemObject")

'________________Setup variables______________________________________

Dim args, num, butype
set args = WScript.Arguments
num = args.Count

if num = 0 then

	dim strNotice 'msgbox text
	strNotice = "Usage: [CScript | WScript] BackUpDirectories.vbs SourceDir [BackupFilespec] [BackupType {Full | Inc} ]" &  vbCRLF &  vbCRLF & "EX: WScript BackUpDirectories.vbs ""C:\My Documents"" E:\Backup Full"
	Msgbox strNotice, vbOKOnly, "BackupDirectories.vbs 2002 BarWareSolutions" 
	WScript.Quit
end if

strSourceDir = args.Item(0) 'Only Directories allowed

strBackupDir = "C:\Backup\" 'This would normally be a CD-R drive, but C as default
if num > 1 then 
	strBackupDir = args.Item(1) & "\"
end if 

FULLBACKUP=vbFALSE
butype = "Incremental"
if num = 3 then
	if args.Item(2) = "Full" then 
		FULLBACKUP=vbTRUE
		butype = "Full"
	end if
end if

strNotice = "SourceDir: " & strSourceDir & vbCRLF & "BackupDir: " & strBackupDir & vbCRLF & "Backup Type: " & butype
If Abs(Msgbox(strNotice & vbCRLF & vbCRLF & "Hit OK to do the backup, Cancel to quit.", vbOKCancel, "BackupDirectories.vbs 2002 BarWareSolutions")) <> 1 then WScript.Quit

'_____________________________________________________________________

set objFolder=objFileSystem.GetFolder(strSourceDir)

if err.number<>0 then 'Source doesn't exist
	wscript.echo "Error - " & Err.number & strSourceDir & " :"& Err.Description
	wscript.quit
end if

SETUPSTUFF=vbTRUE

set colFiles=objFolder.Files
for each FileObj in colFiles

	if FULLBACKUP or (FileObj.Attributes and 32) then 'full backup or archive bit set 

		if SETUPSTUFF then 'Only make directories and log if there is something to backup

			If Not objFileSystem.FolderExists(strBackupDir) then
				objFileSystem.CreateFolder strBackupDir
			end if

			strDay   = Right("00" & Cstr(Day(Date())),2)
			strMonth = Right("00" & Cstr(Month(Date())),2)
			strYear  = Cstr(Year(Date()))
			strBackupDate = strYear & "_" & strMonth & "_" & strDay

			strMinute = Right("00" & Cstr(Minute(Time())),2)
			strHour  = Right("00" & Cstr(Hour(Time())),2)
			strBackupTime = strHour & "_" & strMinute

			strBackupPath = strBackupDir & strBackupDate & "\"
			If Not objFileSystem.FolderExists(strBackupPath) then
			objFileSystem.CreateFolder strBackupPath
			end if

			Dim MyDir', MyName, MyPos
			'MyPos = InStrRev(strSourceDir, "\", -1, 1) 'find last \ position in path
			'MyDir = Right(strSourceDir, Len(strSourceDir) - MyPos) 'save just the directory name
			MyDir = objFileSystem.GetBaseName(strSourceDir)

			strBackupPath = strBackupDir & strBackupDate & "\" & MyDir
			If Not objFileSystem.FolderExists(strBackupPath) then
			objFileSystem.CreateFolder strBackupPath
			end if

			strBackupPath = strBackupDir & strBackupDate & "\" & MyDir & "\" & strBackupTime & "\"
			If Not objFileSystem.FolderExists(strBackupPath) then
			objFileSystem.CreateFolder strBackupPath
			end if

			logfilename = strBackupDate & ".txt"  
			set logfileobj = objFileSystem.OpenTextFile(strBackupPath & logfilename, 8, True)     
			logfileobj.WriteLine "Backup Info:" & vbCRLF & strNotice & vbCRLF & "Created output folder " & strBackupPath & " at " & TIME &vbCRLF

			SETUPSTUFF=vbFALSE
		end if

		strFileName=FileObj.Name 'why am I not using FileObj.name
'		wscript.echo strFileName & VBCRLF & " size: " & FileObj.Size
		logfileobj.WriteLine "Copied: " & strFileName & vbTAB & " size: " & FileObj.Size & vbTAB & " Last Modified: " & FileObj.DateLastModified
		total=total+FileObj.Size
		count=count+1
		objFileSystem.CopyFile strSourceDir & "\" & strFileName, strBackupPath & strFileName
		'FileObj.Attributes = FileObj.Attributes - 32 'clear archive bit
	end if

Next

if NOT SETUPSTUFF then
logfileobj.WriteLine vbCRLF & "TOTALS:" & vbTAB & Count & " files " & Total & " bytes" & VBCRLF & "____________________________________________________________" & vbCRLF

logfileobj.Close
end if

strNotice = "TOTALS:" & vbTAB & Count & " file(s) " & Total & " bytes"
Msgbox strNotice, vbOKOnly, "BackupDirectories.vbs 2002 BarWareSolutions" 

wscript.quit

