'Filename:  BackupFiles.vbs

'Option Explicit
'on Error Resume Next

dim WshShell, objFileSystem, FileObj
dim total, count, strFileName, strSourceFile, FULLBACKUP, SETUPSTUFF

total=0
count=0

Dim strBackupDate, strBackupTime, strBackupDir, strBackupPath, strDay, strMonth, strYear, strMinute, strHour
Dim logfilename, logfileobj

'________________Setup variables______________________________________

Dim args, num, butype
set args = WScript.Arguments
num = args.Count

if num = 0 then

	dim strNotice 'msgbox text
	strNotice = "Usage: [CScript | WScript] BackUpFiles.vbs SourceFile [BackupFilespec] [BackupType {Full | Inc} ]" &  vbCRLF &  vbCRLF & "EX: WScript BackUpFiles.vbs ""C:\My Documents\Resume.doc"" E:\Backup Full"
	Msgbox strNotice, vbOKOnly, "BackupFiles.vbs 2002 BarWareSolutions" 
	WScript.Quit
end if

strSourceFile = args.Item(0) 

strBackupDir = "C:\Backup\" 'This would normally be a CD-R drive, but C as default
if num > 1 then 
	strBackupDir = args.Item(1) & "\"
end if 

FULLBACKUP=vbFALSE
butype = "Incremental"
if num = 3 then
	if args.Item(2) = "Full" then 
		FULLBACKUP=vbTRUE
		butype = "Full"
	end if
end if

strNotice = "SourceFile: " & strSourceFile & vbCRLF & "BackupDir: " & strBackupDir & vbCRLF & "Backup Type: " & butype 
If Abs(Msgbox(strNotice & vbCRLF & vbCRLF & "Hit OK to do the backup, Cancel to quit.", vbOKCancel, "BackupFiles.vbs 2002 BarWareSolutions")) <> 1 then WScript.Quit

'_____________________________________________________________________

Set WshShell=Wscript.CreateObject("Wscript.Shell")
Set objFileSystem=CreateObject("Scripting.FileSystemObject")

if objFileSystem.FileExists(strSourceFile) then 'Test if file exists
	if err.number<>0 then 'Source doesn't exist
		wscript.echo "Error - " & Err.number & strSourceFile & " :"& Err.Description
		wscript.quit
	end if
end if

SETUPSTUFF=vbTRUE

Set FileObj = objFileSystem.GetFile(strSourceFile)

	if FULLBACKUP or (FileObj.Attributes and 32) then 'full backup or archive bit set 

		if SETUPSTUFF then 'Only make directories and log if there is something to backup

			If Not objFileSystem.FolderExists(strBackupDir) then
				objFileSystem.CreateFolder strBackupDir
			end if

			strDay   = Right("00" & Cstr(Day(Date())),2)
			strMonth = Right("00" & Cstr(Month(Date())),2)
			strYear  = Cstr(Year(Date()))
			strBackupDate = strYear & "_" & strMonth & "_" & strDay

			strMinute = Right("00" & Cstr(Minute(Time())),2)
			strHour  = Right("00" & Cstr(Hour(Time())),2)
			strBackupTime = strHour & "_" & strMinute

			strBackupPath = strBackupDir & strBackupDate & "\"
			If Not objFileSystem.FolderExists(strBackupPath) then
				objFileSystem.CreateFolder strBackupPath
			end if


			Dim MyDir, MyName, MyPos
			MyPos = InStrRev(strSourceFile, "\", -1, 1) 'find last \ position in path
			MyName = Right(strSourceFile, Len(strSourceFile) - MyPos) 'save just the filename name
			MyDir = Left(strSourceFile, MyPos - 1) 'save all the directory names, skip the end slash
			MyPos = InStrRev(MyDir, "\", -1, 1) 'find last \ position in path
			MyDir = Right(MyDir, Len(MyDir) - MyPos) 'save just the directory name

'wscript.echo strSourceFile & vbCRLF & MyDir & vbCRLF & MyName

'wscript.echo objFileSystem.GetParentFolderName(strSourceFile) & vbCRLF & _
	objFileSystem.GetBaseName(strSourceFile) & vbCRLF & _ 
	objFileSystem.GetExtensionName(strSourceFile)

'wscript.echo FileObj.ParentFolder & vbCRLF & FileObj.Path

'wscript.quit

			strBackupPath = strBackupDir & strBackupDate & "\" & MyDir
			If Not objFileSystem.FolderExists(strBackupPath) then
			objFileSystem.CreateFolder strBackupPath
			end if

			strBackupPath = strBackupDir & strBackupDate & "\" & MyDir & "\" & strBackupTime & "\"
			If Not objFileSystem.FolderExists(strBackupPath) then
			objFileSystem.CreateFolder strBackupPath
			end if

			logfilename = strBackupDate & ".txt"  
			set logfileobj = objFileSystem.OpenTextFile(strBackupPath & logfilename, 8, True)     
			logfileobj.WriteLine "Backup Info:" & vbCRLF & strNotice & vbCRLF & "Created output folder " & strBackupPath & " at " & TIME &vbCRLF
  
			SETUPSTUFF=vbFALSE
		end if

		logfileobj.WriteLine "Copied: " & strSourceFile & vbTAB & " size: " & FileObj.Size & vbTAB & " Last Modified: " & FileObj.DateLastModified
		total=total+FileObj.Size
		count=count+1
		objFileSystem.CopyFile strSourceFile, strBackupPath & Right(strFileName, Len(strSourceFile) - 3)
		'FileObj.Attributes = FileObj.Attributes - 32 'clear archive bit
	end if

if NOT SETUPSTUFF then
	logfileobj.WriteLine VBCRLF & "TOTALS:" & vbTAB & Count & " files " & Total & " bytes" & VBCRLF & "____________________________________________________________" & vbCRLF
	logfileobj.Close
end if

strNotice = "TOTALS:" & vbTAB & Count & " file(s) " & Total & " bytes"
Msgbox strNotice, vbOKOnly, "BackupFiles.vbs 2002 BarWareSolutions" 

wscript.quit

